SystemOrganization addCategory: #Everett!

Object subclass: #EntityManager
	instanceVariableNames: 'nextAvailableEntity entityTable entityTags changedEntities removedEntities'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Everett'!

!EntityManager methodsFor: 'create-modify-destroy' stamp: 'EricShahkarami 7/1/2013 10:32'!
addComponent: aComponentInstance toEntity: anEntity

	(anEntity < nextAvailableEntity and: anEntity >= 0) ifTrue: 
	[  
		self atEntity: anEntity putComponent: aComponentInstance.
		changedEntities add: anEntity
	]! !

!EntityManager methodsFor: 'private' stamp: 'EricShahkarami 6/30/2013 11:54'!
atEntity: anEntity
	
	^(entityTable at: anEntity)! !

!EntityManager methodsFor: 'private' stamp: 'EricShahkarami 6/30/2013 12:03'!
atEntity: anEntity putComponent: aComponentInstance 
		
	(entityTable at: anEntity) at: (aComponentInstance class identity) put: aComponentInstance. ! !

!EntityManager methodsFor: 'accessing' stamp: 'EricShahkarami 7/1/2013 10:49'!
changedEntities
	^changedEntities ! !

!EntityManager methodsFor: 'accessing' stamp: 'EricShahkarami 6/30/2013 22:35'!
component: aComponentIdentifier fromEntity: anEntity

	| componentsOfEntity |
	
	componentsOfEntity := self atEntity: anEntity.
	^(componentsOfEntity at: aComponentIdentifier)! !

!EntityManager methodsFor: 'create-modify-destroy' stamp: 'EricShahkarami 7/1/2013 10:35'!
createEntity

	entityTable at: nextAvailableEntity put: (Dictionary new).	
	changedEntities add: nextAvailableEntity.
	nextAvailableEntity := nextAvailableEntity + 1.
	^(nextAvailableEntity - 1)
! !

!EntityManager methodsFor: 'create-modify-destroy' stamp: 'EricShahkarami 7/1/2013 10:36'!
createEntityFromTag: aTag

	"Create a replica of a tagged entity"! !

!EntityManager methodsFor: 'accessing' stamp: 'EricShahkarami 6/27/2013 16:30'!
entitiesMatching: aComponentExpression! !

!EntityManager methodsFor: 'initialize-release' stamp: 'EricShahkarami 7/1/2013 10:30'!
initialize 
	
	super initialize.
	entityTable := Dictionary new.
	entityTags := Dictionary new.
	changedEntities := Set new.
	removedEntities := Set new.
	nextAvailableEntity := 0! !

!EntityManager methodsFor: 'create-modify-destroy' stamp: 'EricShahkarami 7/1/2013 10:53'!
removeComponent: aComponentIdentifier fromEntity: anEntity

	| componentsOfEntity |
	
	componentsOfEntity := self atEntity: anEntity.
	componentsOfEntity removeKey: aComponentIdentifier.
	changedEntities add: anEntity
! !

!EntityManager methodsFor: 'create-modify-destroy' stamp: 'EricShahkarami 7/1/2013 10:43'!
removeEntity: anEntity	
	"Removes entity from entityTable and places entity in removed dictionary."	
	
	entityTable removeKey: anEntity.
	removedEntities add: anEntity
	! !

!EntityManager methodsFor: 'create-modify-destroy' stamp: 'EricShahkarami 6/27/2013 14:12'!
removeTag: aTag! !

!EntityManager methodsFor: 'accessing' stamp: 'EricShahkarami 7/1/2013 10:49'!
removedEntities
	^removedEntities ! !

!EntityManager methodsFor: 'create-modify-destroy' stamp: 'EricShahkarami 6/30/2013 11:58'!
tagEntity: anEntity with: aTag! !

Object subclass: #EverettComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Everett'!

!EverettComponent class methodsFor: 'instance creation' stamp: 'EricShahkarami 6/27/2013 13:52'!
identity
	^self subclassResponsibility! !

Object subclass: #EverettSystem
	instanceVariableNames: 'updateInterval matchingEntities'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Everett'!

!EverettSystem class methodsFor: 'instance creation' stamp: 'EricShahkarami 6/27/2013 14:20'!
identity
	^self subclassResponsibility ! !

!EverettSystem class methodsFor: 'instance creation' stamp: 'EricShahkarami 6/27/2013 16:26'!
updateInterval: anUpdateInterval
	^(self new updateInterval: anUpdateInterval)! !

!EverettSystem methodsFor: 'processing' stamp: 'EricShahkarami 6/27/2013 16:08'!
updateEntitiesOf: anEntityManager afterTimeDelta: dt! !

!EverettSystem methodsFor: 'processing' stamp: 'EricShahkarami 6/27/2013 16:27'!
updateEntity: anEntity afterTimeDelta: dt! !

!EverettSystem methodsFor: 'initialize-release' stamp: 'EricShahkarami 6/27/2013 16:26'!
updateInterval: anUpdateInterval
	updateInterval := anUpdateInterval ! !

Object subclass: #SystemManager
	instanceVariableNames: 'systems'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Everett'!

!SystemManager methodsFor: 'create-modify-destroy' stamp: 'EricShahkarami 6/27/2013 14:16'!
addSystem: aSystemInstance 
	! !

!SystemManager methodsFor: 'create-modify-destroy' stamp: 'EricShahkarami 6/27/2013 16:12'!
addSystem: aSystem withPriority: aPriority! !

!SystemManager methodsFor: 'create-modify-destroy' stamp: 'EricShahkarami 6/28/2013 12:15'!
assignSystem: aSystemIdentifier aPriorityOf: aPriority! !

!SystemManager methodsFor: 'create-modify-destroy' stamp: 'EricShahkarami 6/28/2013 12:15'!
removeSystem: aSystemIdentifier! !

!SystemManager methodsFor: 'processing' stamp: 'EricShahkarami 6/27/2013 16:08'!
updateEntitiesOf: anEntityManager afterTimeDelta: dt! !
